#! /usr/bin/python

# To change this template, choose Tools | Templates
# and open the template in the editor.

__author__="bjschuma"
__date__ ="$Dec 19, 2009 9:39:37 PM$"


from bt.message import write
import manager
from session import settings
from session import events

# Command line related imports
from addch import addch
from message import *

global halt
halt = True



def init():
	write("Beginning command line loop",True)
	# Initialize ncurses screen
	stdscr = curses.initscr()
	maxyx = stdscr.getmaxyx()
	curses.cbreak()
	curses.noecho()
	stdscr.keypad(1)
	curses.halfdelay(10)
	
	# Set these values in settings class for use elsewhere
	settings["stdscr"] = stdscr
	settings["maxyx"] = maxyx
	settings.init("prompt",">>>")
	settings["prompt"] += " "

	settings.init("maxhist",50)

	settings["clinex"] = 0
	settings["cliney"] = 0
	events.invite("message-write", insert,90)



def quit():
	# Halt our loop
	global halt

	if halt == True:
		return
	halt = True

	# Undo ncurses initialization
	curses.nocbreak()
	curses.echo()
	settings["stdscr"].keypad(0)
	curses.endwin()

	# Delete keys that settings no longer needs
	del settings["stdscr"]
	del settings["maxyx"]
	del settings["cliney"]
	del settings["clinex"]

	# Return to previous write function
	events.uninvite("message-write",insert)
	write("Command line loop has ended",True)



# Loop around until the plugin manager calls shutdown
def loop():
	global halt

	halt = False

	init()

	stdscr = settings["stdscr"]
	input = settings["prompt"]
	write("Type \"help\" for a list of valid commands")
	disp(input)

	while halt == False:
		events.start("cli-loop-begin")
		try:
			input = addch(input)
			disp(input)
		except:
			pass
		events.start("cli-loop-end")


